import pytest
from ee.kicad import parse_ref

@pytest.mark.parametrize("ref,expected", [
    ("C12", ("C", 12)),
    ("C12?", None),
    ("C?", ("C", None)),
    ("junk", None),
])
def test_parse_ref(ref, expected):
    if expected is None:
        assert parse_ref(ref) is None
        return

    (expected_ref, expected_num) = expected
    (actual_ref, actual_num) = parse_ref(ref)
    assert expected_ref == actual_ref
    assert expected_num == actual_num
